Subject: Answers to Frequently Asked MOO Question (FAQ)

From: [email-masked] (Wayne E. Bouchard)
Date: Tue, 2 Nov 1993 16:10:01 -0800

[Last updated November 1, 1993]

Database and Programming:
------------------------
1) Q: I want to start my own MOO. Where do I get the source?

   A: The standard MOO archive is parcftp.xerox.com in the directory pub/MOO.

      The file `LambdaMOO-X.Y.Z.tar.Z' (for a current server version of
      X.Y.Z) is a compressed tar file containing the complete source code,
      installation instructions, and a copy of the `Minimal' LambdaMOO
      database.

      The file `LambdaCore-DDMMMYY.db' (for some date DDMMMYY) is a
      LambdaMOO database file containing the `core' of the running LambdaMOO
      database as of the specified date.  This is almost certainly the
      easiest place for you to start from in creating your own MOO, since
      this includes such useful things as the various generics (room,
      player, exit, thing, container, note, etc.), the MOO text editors, the
      MOO mail system, etc.

      The `binaries' subdirectory contains already-compiled executables of
      the current release for various machines.

2) Q: What is this programmer's manual everybody talks about and where
      can I get it?

   A: The "LambdaMOO Programmer's Manual" is a complete reference for all
      database-independent aspects of the LambdaMOO system, including the
      programming language, built-in functions, and command parser.

      The Programmer's Manual is availible via anonymous FTP at
      parcftp.xerox.com in the directory /pub/MOO/. The file name is
      `ProgrammersManual.*' where `*' is the format tag. It is availible in
      DVI, PostScript, TeXInfo, and plain text formats.

3) Q: Is there a way to incorporate new features of LambdaCore into my
      MOO's DB?

   A: There is no easy way to merge databases. The easiest thing to do is
      just snag the code from LambdaMOO or somewhere and build the objects
      by hand. (For information on how to do so, see `help @dump' on
      LambdaMOO.)

4) Q: How do I do execute a verb automatically each time the server starts?

   A: When the server starts, it calls the verb #0:server_started.
      Create/alter that verb to have it call the verb you want to execute.
      
      (NOTE: If a task has suspended or forked, and its execution is
      still pending when the server checkpoints or is shutdown, that
      task is saved along with the rest of the database. Thus, when
      the server is restarted, that task will be resumed.)

5) Q: How can I make an object in a room "listen" to everything that's
      being said?

   A: When something is said in a room, each object in that room is sent
      that text via :tell. You can hack this verb to do whatever you want it
      to whenever anything is said or done in a room.

6) Q: My MOO checkpoints every hour. I want to change this but I don't
      know where to look.

   A: Change the value of the property #0.dump_interval to the desired
      number of seconds between dumps; the change will take effect after the
      next checkpoint.

      This is documented in the LambdaMOO Programmer's Manual, section 4.2.2,
      Database Checkpointing Frequency.

Server Related:
--------------

1) Q: What are the minimum requirements for running a MOO?

   A: The LambdaCore database is approximately 2 megabytes in size. The
      source and executable for MOO will likely occupy another 1-2 Megs. In
      its current state, MOO resides entirely in resident memory when
      running. The process size is going to be roughly 2-3 times the
      size of the database file on disk.

2) Q: I'm running a MOO on a NeXT but every once in a while it crashes
      with a 'vm_allocate failed' error. What's wrong?

   A: This is a bug in the NeXT's operating system and not in the MOO
      server.  The current best guess as to the cause is massive
      fragmentation in either the virtual memory system or in the memory
      managed by malloc() and free().

3) Q: I've heard a lot about the next release. When is it due out?

   A: It is unpredictable when each new version of the server will be
      released. Pavel Curtis (The developer of LambdaMOO) has
      estimated that 1.8.0 might well be out sometime in the fall of this
      year (1993), but no specific date can confidently be relied upon.

Miscellaneous:
-------------

1) Q: What are some good clients to use with MOO?

   A: Most people prefer to use TinyFugue or the emacs client, mud.el.
      mud.el is availible at parcftp.xerox.com in the directory
      pub/MOO/clients/. As for other clients, you might try poking around at
      ftp.math.okstate.edu in the directory pub/mud/clients/.

2) Q: What are all the MOOs currently out there?

   A: Its hard to keep an accurate list of all public MOOs, but here's
      my best info:

	Name               Address                 Numeric Address Port
	---------------------------------------------------------------
	LambdaMOO          lambda.parc.xerox.com   13.2.116.36     8888
         (The original)
	ZenMOO             cheshire.oxy.edu        134.69.1.253    7777
	ScrabbleMOO        next2.cas.muohio.edu    134.53.14.112   7777
	OpalMOO            cc.brynmawr.edu         130.58.85.1     7777
	PMC-MOO            dewey.lib.ncsu.edu      152.1.24.90     7777
	VampireMOO         pluto.cs.trinity.edu    131.194.131.20  7777
	TechMOOseum        whyanext.com            156.151.253.1   8888
	MagicMOO           dougal.aston.ac.uk      134.151.36.1    7777
	JanusMOO           sun10.sep.bnl.gov       130.199.50.6    8888
        BayMOO             mud.crl.com             165.113.1.30    8888
        Harper's Tale MOO  salmon.csb.ki.se        130.237.204.6   8888

      [ EDITOR'S NOTE: Some MOOs have been purposely omitted at the request
        of their administrators. If you wish to add _your_ MOO to this list,
        please send mail to the address listed below. ]

3) Q: How do I subscribe/unsubscribe to/from this list?

   A: Send an email message to [email-masked] with your
      request to be added to or deleted from the MOO-Cows mailing list.

-------------------------------------------------------------------------------

The "MOO Frequently Asked Question List" is maintained by
Wayne E. Bouchard ([email-masked]).  Direct all questions or
comments concerning this list to him.  Submissions and questions are
welcome and appreciated.  This list will be posted again on the first
of next month.